CREATE TABLE `DT_DATUM_GRID` (`GridID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`EpsgCode` INT  NULL DEFAULT NULL,`Region` TEXT  NULL ,`Country` TEXT  NULL ,`GridName` TEXT  NULL ,`Type` TEXT  NULL ,`Lon0` REAL(24,0)  NULL DEFAULT NULL,`Lat0` REAL(24,0)  NULL DEFAULT NULL,`Lat1` REAL(24,0)  NULL DEFAULT NULL,`Lat2` REAL(24,0)  NULL DEFAULT NULL,`GridScale` REAL(24,0)  NULL DEFAULT NULL,`FalseEasting` REAL(24,0)  NULL DEFAULT NULL,`FalseNorthing` REAL(24,0)  NULL DEFAULT NULL,`DatumName` TEXT  NULL ,`SemiMajorAxis` TEXT  NULL ,`InvFlattening` TEXT  NULL ,`DeltaX` REAL(24,0)  NULL DEFAULT NULL,`DeltaY` REAL(24,0)  NULL DEFAULT NULL,`DeltaZ` REAL(24,0)  NULL DEFAULT NULL,`RotX` REAL(24,0)  NULL DEFAULT NULL,`RotY` REAL(24,0)  NULL DEFAULT NULL,`RotZ` REAL(24,0)  NULL DEFAULT NULL,`DatumScale` REAL(24,0)  NULL DEFAULT NULL,`SouthBound_Lat` REAL(24,0)  NULL DEFAULT NULL,`NorthBound_Lat` REAL(24,0)  NULL DEFAULT NULL,`WestBound_Lon` REAL(24,0)  NULL DEFAULT NULL,`EastBound_Lon` REAL(24,0)  NULL DEFAULT NULL,`EllipsoidName`  TEXT,`TypeOld`  TEXT,`UnitScale`  REAL(24),`VertScale`  REAL(24),`dDx`  REAL(24),`dDy`  REAL(24),`dDz`  REAL(24),`dRx`  REAL(24),`dRy`  REAL(24),`dRz`  REAL(24),`dDs`  REAL(24));

CREATE TABLE IF NOT EXISTS `DT_VIEW` (`ViewID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`Name` NVARCHAR(100)  NOT NULL ,`TargetX` REAL(24,0)  NULL DEFAULT NULL,`TargetY` REAL(24,0)  NULL DEFAULT NULL,`TargetZ` REAL(24,0)  NULL DEFAULT NULL,`Distance` REAL(24,0)  NULL DEFAULT NULL,`Rotate` REAL(24,0)  NULL DEFAULT NULL,`Tilt` REAL(24,0)  NULL DEFAULT NULL,`Precision` REAL(24,0)  NULL DEFAULT NULL,`NightColor` INT  NULL DEFAULT NULL,`BackColor` INT  NULL DEFAULT NULL,`EditLayer` INT  NULL DEFAULT NULL,`Encoding` TEXT  NULL ,`CodeDict` TEXT  NULL ,`GridID` INT  NULL DEFAULT NULL,CONSTRAINT `FK_DT_VIEW_DT_GRID` FOREIGN KEY (`GridID`) REFERENCES DT_DATUM_GRID (`GridID`));


CREATE TABLE IF NOT EXISTS `DT_BOOKMARK` (`BookmarkID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`ViewID` INT  NULL DEFAULT NULL,`Name` TEXT  NULL ,`TargetX` REAL(24,0)  NULL DEFAULT NULL,`TargetY` REAL(24,0)  NULL DEFAULT NULL,`TargetZ` REAL(24,0)  NULL DEFAULT NULL,`Distance` REAL(24,0)  NULL DEFAULT NULL,`Rotate` REAL(24,0)  NULL DEFAULT NULL,`Tilt` REAL(24,0)  NULL DEFAULT NULL,CONSTRAINT `FK_DT_BOOKMARK_DT_VIEW` FOREIGN KEY (`ViewID`) REFERENCES DT_VIEW (`ViewID`));


CREATE TABLE IF NOT EXISTS `DT_CONNECTION_STRING` (`ConnectionStringID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`Name` NVARCHAR(100)  NULL DEFAULT NULL,`Provider` TEXT  NULL ,`ConnectionString` TEXT  NULL ,`Login` TEXT  NULL ,`Password` TEXT  NULL );

CREATE UNIQUE INDEX IF NOT EXISTS UQ_DT_CONNECTION_STRING_NAME ON DT_CONNECTION_STRING (`Name` DESC);


CREATE TABLE IF NOT EXISTS `DT_SOURCE` (`SourceID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`SourceType` INT  NULL DEFAULT NULL,`Source` TEXT  NULL ,`GeomType` INT  NULL DEFAULT NULL,`GeomField` TEXT  NULL ,`ConnectionStringID` INT  NULL DEFAULT NULL,`RasterXX` REAL(24,0)  NULL DEFAULT NULL,`RasterXY` REAL(24,0)  NULL DEFAULT NULL,`RasterDX` REAL(24,0)  NULL DEFAULT NULL,`RasterYX` REAL(24,0)  NULL DEFAULT NULL,`RasterYY` REAL(24,0)  NULL DEFAULT NULL,`RasterDY` REAL(24,0)  NULL DEFAULT NULL,`GridID` INT  NULL DEFAULT NULL,CONSTRAINT `FK_DT_SOURCE_DT_CONNECTION_STRING` FOREIGN KEY (`ConnectionStringID`) REFERENCES DT_CONNECTION_STRING (`ConnectionStringID`),CONSTRAINT `FK_DT_SOURCE_DT_DATUM_GRID` FOREIGN KEY (`GridID`) REFERENCES DT_DATUM_GRID (`GridID`));


CREATE TABLE IF NOT EXISTS `DT_LAYER` (`LayerID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`ViewID` INT  NOT NULL ,`SourceID` INT  NOT NULL ,`Layer` TEXT  NULL ,`LayerType` INT  NULL DEFAULT NULL,`DisplayOrder` INT  NULL DEFAULT NULL,`Visible` INT  NULL DEFAULT NULL,`LayerInfo` INT  NULL DEFAULT NULL,`ScaleMin` INT  NULL DEFAULT NULL,`ScaleMax` INT  NULL DEFAULT NULL,`ClassFieldID` INT  NULL DEFAULT NULL,`ClassType` INT  NULL DEFAULT NULL,`Palette` INT  NULL DEFAULT NULL,`LinkFieldID` INT  NULL DEFAULT NULL,`PosX` REAL(24,0)  NULL DEFAULT NULL,`PosY` REAL(24,0)  NULL DEFAULT NULL,`Transparency` INT  NULL DEFAULT NULL,`Brightness` INT  NULL DEFAULT NULL,`Contrast` INT  NULL DEFAULT NULL,`Editable` INT  NULL DEFAULT NULL,`LabelShow` INT  NULL DEFAULT NULL,`LabelScale` INT  NULL DEFAULT NULL,`LabelShowSymbol` INT  NULL DEFAULT NULL,`LabelSymbolScale` INT  NULL DEFAULT NULL,`LabelFieldID1` INT  NULL DEFAULT NULL,`LabelFieldID2` INT  NULL DEFAULT NULL,`LabelFieldID3` INT  NULL DEFAULT NULL,`LabelFont` TEXT  NULL ,`LabelSizeNum` REAL(24,0)  NULL DEFAULT NULL,`LabelSizeFieldID` INT  NULL DEFAULT NULL,`LabelStyle` INT  NULL DEFAULT NULL,`LabelForeColor` INT  NULL DEFAULT NULL,`LabelBackColor` INT  NULL DEFAULT NULL,`TrRed` INT  NULL DEFAULT NULL,`TrGreen` INT  NULL DEFAULT NULL,`TrBlue` INT  NULL DEFAULT NULL,`TrTransparent` INT  NULL DEFAULT NULL,CONSTRAINT `FK_DT_LAYER_DT_SOURCE` FOREIGN KEY (`SourceID`) REFERENCES DT_SOURCE (`SourceID`),CONSTRAINT `FK_DT_LAYER_DT_VIEW` FOREIGN KEY (`ViewID`) REFERENCES DT_VIEW (`ViewID`));


CREATE TABLE IF NOT EXISTS `DT_CLASS` (`ClassID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`LayerID` INT  NULL DEFAULT NULL,`ClassMin` TEXT  NULL ,`ClassMax` TEXT  NULL ,`Text` TEXT  NULL ,`Label` TEXT  NULL ,`LineColor` INT  NULL DEFAULT NULL,`FillColor` INT  NULL DEFAULT NULL,`Symbol` INT  NULL DEFAULT NULL,`LineType` INT  NULL DEFAULT NULL,`FillType` INT  NULL DEFAULT NULL,`Texture` INT  NULL DEFAULT NULL,`DispScale` REAL(24,0)  NULL DEFAULT NULL,`LabScale` REAL(24,0)  NULL DEFAULT NULL,CONSTRAINT `FK_DT_CLASS_DT_LAYER` FOREIGN KEY (`LayerID`) REFERENCES DT_LAYER (`LayerID`));


CREATE TABLE IF NOT EXISTS `DT_ENUM_TABLE` (`EnumTableID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`Type` INT  NULL DEFAULT NULL,`Name` NVARCHAR(100)  NULL DEFAULT NULL);

CREATE UNIQUE INDEX IF NOT EXISTS UQ_DT_ENUM_TABLE_Name ON DT_ENUM_TABLE (`Name` DESC);


CREATE TABLE IF NOT EXISTS `DT_ENUM_CODE` (`EnumCodeID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`EnumTableID` INT  NULL DEFAULT NULL,`Code` NVARCHAR(100)  NULL DEFAULT NULL,`Name` TEXT  NULL ,`Description` TEXT  NULL ,`Color` INT  NULL DEFAULT NULL,`Symbology` INT  NULL DEFAULT NULL,`Filter` TEXT  NULL ,CONSTRAINT `FK_DT_ENUM_CODE_DT_ENUM_TABLE` FOREIGN KEY (`EnumTableID`) REFERENCES DT_ENUM_TABLE (`EnumTableID`));

CREATE UNIQUE INDEX IF NOT EXISTS UQ_DT_ENUM_CODE_EnumTableID_Code ON DT_ENUM_CODE (`EnumTableID` DESC,`Code` DESC);


CREATE TABLE IF NOT EXISTS `DT_FIELD` (`FieldID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`LayerID` INT  NULL DEFAULT NULL,`Field` TEXT  NULL ,`DefVal` INT  NULL DEFAULT NULL,`Expr` TEXT  NULL ,`Rule` INT  NULL DEFAULT NULL,`Min` TEXT  NULL ,`Max` TEXT  NULL ,`Pos` INT  NULL DEFAULT NULL,`Alias` TEXT  NULL ,`Doc` BLOB  NULL ,`EnumTableID` INT  NULL DEFAULT NULL,`EnumFilter` TEXT  NULL ,CONSTRAINT `FK_DT_FIELD_DT_LAYER` FOREIGN KEY (`LayerID`) REFERENCES DT_LAYER (`LayerID`),CONSTRAINT `FK_DT_FIELD_DT_ENUM_TABLE` FOREIGN KEY (`EnumTableID`) REFERENCES DT_ENUM_TABLE (`EnumTableID`));


CREATE TABLE IF NOT EXISTS `DT_FILTER` (`FilterID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`FieldID` INT  NULL DEFAULT NULL,`Condition` INT  NULL DEFAULT NULL,`FilterRelation` INT  NULL DEFAULT NULL,`FilterNum` INT  NULL DEFAULT NULL,`FilterText` TEXT  NULL ,`FilterAnd` INT  NULL DEFAULT NULL,`CompStr` INT  NULL DEFAULT NULL,CONSTRAINT `FK_DT_FILTER_DT_FIELD` FOREIGN KEY (`FieldID`) REFERENCES DT_FIELD (`FieldID`));


CREATE TABLE IF NOT EXISTS `DT_META` (`MetaID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`TableName` NVARCHAR(100)  NOT NULL ,`RasterID` INT  NULL DEFAULT NULL,`ProjText` TEXT  NULL ,`MetaText` TEXT  NULL );

CREATE UNIQUE INDEX IF NOT EXISTS DT_META_UQ_DT_PROJ_RASTERID_TABLENAME ON DT_META (`RasterID` DESC,`TableName` DESC);


CREATE TABLE IF NOT EXISTS `DT_RASTER` (`RasterID` INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL ,`Name` NVARCHAR(100)  NULL DEFAULT NULL,`Binary` BLOB  NULL ,`Type` TEXT  NULL ,`Header` TEXT  NULL );

CREATE UNIQUE INDEX IF NOT EXISTS UQ_DT_RASTER_Name ON DT_RASTER (`Name` DESC);
